CON
  _clkmode = xtal1 + pll16x
  _xinfreq = 5_000_000
  #1, HOME, #8, BKSP, TAB, LF, CLREOL, CLRLB, CR, #16, CLS      ' PST formmatting control  
  CLK = 24
  DATA = 25
  CS = 26
OBJ
  Sio  : "Parallax Serial Terminal"        
  vp : "Conduit"                             ' Declare ViewPort conduit
  qs : "QuickSample"                         ' Declare 
  Ram : "sram_contr20Mod"
  vm : "vmcog"                  ' the MMU/virtual memory manager cog

VAR
  long r, c, i, j, k, move, moveX, moveY
  long data1[1024]       ' 32x32
  long map[25]          ' 5x5
  long start, end
  long command
  long mailbox[4]


Pub Main 
  Sio.startRxTx(31,30,0,115200)  ' Rx,Tx, Mode, Baud
  Ram.Start(DATA, 0, CS, CLK, @command)
'  vm.start(@mailbox,$7C00,16) ' start up VMCOG
'  Sio.startRxTx(8,9,0,115200)  ' Rx,Tx, Mode, Baud      XBee
'  vp.register(qs.sampleINA(@frame,1))        'sample INA into <frame> array
'  vp.share(@chlong, @chlong)
  waitcnt(clkfreq * 3 + cnt)
{ hub ram
  k := 0
  repeat i from 0 to 31
    repeat j from 0 to 31
      data1[i*32 + j] := k++   }
' SPI Ram      
  k := 0
  repeat i from 0 to 89
    repeat j from 0 to 89
      Ram.WriteLong(i*90 + j, k++)  

' VM Ram
{  k := 0
  repeat i from 0 to 89
    repeat j from 0 to 89
      vm.wrvlong(i*90 + j, k++)  }
      
  r := 2
  c := 2

      
  move := 12345
  start := cnt
  repeat 1000
    move?
    moveX :=  (||move // 3) - 1
    move?
    moveY :=  (||move // 3) - 1 
    r += moveX
    c += moveY
{  hub ram    
    r := 2 #> r <# 29
    c := 2 #> c <# 29
    k := 0
    repeat i from r-2 to r+2
      repeat j from c-2 to c+2
        map[k++] := data1[i * 32 + j] }       
'  SPI Ram
    r := 2 #> r <# 87
    c := 2 #> c <# 87
    k := 0
    repeat i from r-2 to r+2
      repeat j from c-2 to c+2
        map[k++] := Ram.ReadLong((i * 90 + j)*4)  
'   VM Ram             
{    r := 2 #> r <# 87
    c := 2 #> c <# 87
    k := 0
    repeat i from r-2 to r+2
      repeat j from c-2 to c+2
        map[k++] := vm.rdvLong((i * 90 + j)*4)  }

  end := cnt
  sio.dec((end - start-755)/80_000) ' time in milliseconds
  sio.char(cr)

'' raw loop was 755 milliseconds reading data from hub to hub was 1505 milliseconds delta is 750 milliseconds
'' total read/assignments is 25,000 or 30 microseconds per read/assign
'' for spi ram  8,192 longs or 32,768 bytes will use 90x90 or 8100 longs 32,400 bytes
'' for spi ram 10040 or 402 microseconds per read/assign
'' for spi virtual ram with 2k bytes hub ram 6546 milliseconds or 262 microseconds per read/assign
'' for spi virtual ram with 4k bytes hub ram 4657 milliseconds or 186 microseconds per read/assign
'' for spi virtual ram with 8k bytes hub ram 2998 milliseconds or 120 microseconds per read/assign